#ifndef LB_D2Q9_VDW_H
#define LB_D2Q9_VDW_H

#include <lb-VdW.h>
#include <lb-macros.h>
#include <lb-partition-info.h>

LB_BEGIN_DECLS

typedef struct {
	double min_density;
	double max_density;
	double max_velocity;
	double kin_energy;
	double momentum_x;
	double momentum_y;
} LBD2Q9VdWStats;

typedef struct _LBD2Q9VdW LBD2Q9VdW;

LBD2Q9VdW* lb_d2q9_VdW_new(int nx, int ny, int py);
void lb_d2q9_VdW_destroy(LBD2Q9VdW*);

void lb_d2q9_VdW_partition_info(const LBD2Q9VdW*, LBPartitionInfo*);

void lb_d2q9_VdW_set_parameters(LBD2Q9VdW*, const LBVdWParameters*);
void lb_d2q9_VdW_get_parameters(const LBD2Q9VdW*, LBVdWParameters*);

void lb_d2q9_VdW_set_walls_speed(LBD2Q9VdW*, double top, double bottom);
void lb_d2q9_VdW_get_walls_speed(const LBD2Q9VdW*, double*, double*);

void lb_d2q9_VdW_set_averages(LBD2Q9VdW*, int x, int y, double density,
				double velocity_x, double velocity_y);
void lb_d2q9_VdW_get_averages(const LBD2Q9VdW*, int x, int y,
				double* density,
				double* velocity_x, double* velocity_y);

void lb_d2q9_VdW_setup_equilibrium_pdfs(LBD2Q9VdW*);
void lb_d2q9_VdW_advance(LBD2Q9VdW*);
void lb_d2q9_VdW_dump(const LBD2Q9VdW*, const char* filename);

void lb_d2q9_VdW_stats(const LBD2Q9VdW*, LBD2Q9VdWStats*);

// remove this
double lb_d2q9_VdW_mass(const LBD2Q9VdW*);

LB_END_DECLS

#endif /* LB_D2Q9_VDW_H */
