#ifndef LB_RGB_H
#define LB_RGB_H

#include <stdio.h>
#include <lb-macros.h>
#include <lb-colormap.h>

LB_BEGIN_DECLS

typedef struct _LBRGB LBRGB;

LBRGB* lb_rgb_new(int width, int height);
void lb_rgb_destroy(LBRGB*);

int lb_rgb_width(const LBRGB*);
int lb_rgb_height(const LBRGB*);

void lb_rgb_fill(LBRGB*, const double rgb[3]);
void lb_rgb_get_pixel(const LBRGB*, int x, int y, double rgb[3]);
void lb_rgb_set_pixel(LBRGB*, int x, int y, const double rgb[3]);
void lb_rgb_set_pixel_rgba(LBRGB*, int, int, const double rgba[4]);

void lb_rgb_map_value(LBRGB*, const LBColormap*, int, int, double);

void lb_rgb_save(const LBRGB*, FILE*);

LB_END_DECLS

#endif /* LB_RGB_H */
