#ifndef LBLUA_CLASS_H
#define LBLUA_CLASS_H

#include <lua.h>
#include <lauxlib.h>
#include <lb-macros.h>

LB_BEGIN_DECLS

/*
 *  assume either 'modulename != NULL' or 'lua_istable(ls, -1) == TRUE';
 */

void lblua_register_class(lua_State*, const char* modulename,
			    const char* classname,
			    lua_CFunction ctor, lua_CFunction dtor,
			    const luaL_reg* methods);

/*
 *  semantics is the same as for 'luaL_checkXXX()' functions
 */

void* lblua_checkudata(lua_State*, int, const char*);
#define lblua_checkinstance(type, ls, narg, name)	\
	*((type**) lblua_checkudata(ls, narg, name))


LB_END_DECLS

#endif /* LBLUA_CLASS_H */
