#ifndef LBLUA_UTILS_H
#define LBLUA_UTILS_H

#include <lua.h>
#include <lb-macros.h>

LB_BEGIN_DECLS

void lblua_checkargcount(lua_State* ls, int count, const char* function);
int  lblua_range_error(lua_State* ls, const char* function);

void lblua_push_array_int(lua_State* ls, int count, const int* data);
int lblua_check_array_int(lua_State* ls, int idx, int bsize, int* buf);

void lblua_push_array_double(lua_State* ls, int count, const double* data);
int lblua_check_array_double(lua_State* ls, int idx, int bsize, double* buf);

void lblua_push_simple_table(lua_State* ls, int count,
			       const char* keys[], const double vals[]);
void lblua_check_simple_table(lua_State* ls, int idx, int count,
			        const char* keys[], double vals[]);

LB_END_DECLS

#endif /* LBLUA_UTILS_H */
